<?php
/**
* @version		$Id: helper.php
* @package		Joomla
* @copyright		Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');


class modTopExtravoteHelper
{

	function getList(&$params)
	{
		global $mainframe;
		$count		= intval($params->get('count', 5));
		$catid		= trim($params->get('catid'));
		$secid          = trim($params->get('secid'));
		$daughter	= trim($params->get('show_daughter',0));
		$days		= intval($params->get('days', 7));
		$usetitlealias	= intval($params->get('usetitlealias'));
		$source_data	= intval($params->get('source_data',1));
		$order_by	= $params->get('order_by');
		$checklang	= $params->get('checklang','1');
		$db		= &JFactory::getDBO();
		$secCondition	='';
		$catCondition	='';
		$noidCondition	='';

		$where = ' ';
		if ($catid) {
			$ids = explode(',', $catid);
			JArrayHelper::toInteger($ids);
			$where .= ' AND (ar.catid='.implode(' OR ar.catid=', $ids).')';
		}
		if ((!modTopExtravoteHelper::ext_isJoomla('1.6', '>=')) && ($secid)) {
			$ids = explode(',', $secid);
			JArrayHelper::toInteger($ids);
			$where .= ' AND (ar.sectionid='.implode(' OR ar.sectionid=', $ids).')';
		}
		if (modTopExtravoteHelper::ext_isJoomla('1.6', '>=') && $catid && $daughter) {
			$ids = array_unique(explode(',', modTopExtravoteHelper::listChilds($db, $ids)));
			JArrayHelper::toInteger($ids);
			$where = ' AND (ar.catid='.implode(' OR ar.catid=', $ids).')';
		}

		if ($checklang == '1') {
			$document = &JFactory::getDocument();
			$lang = strtolower($document->language); //  
			if (modTopExtravoteHelper::ext_isJoomla('1.6', '>=')) $where .= 'and ((LOWER(ar.language)="'.$lang.'") or (LOWER(ar.language)="*")) ';
			else $where .= ' and ((LOWER(ar.attribs) like "%language='.$lang.'%") or (LOWER(ar.attribs) like "%language=\nkeyref%")) ';
		}

		if ($source_data == 0) {
			$query = 'SELECT a.content_id as id,a.rating_count as hits,a.rating_sum as summ,ROUND((a.rating_sum/a.rating_count),2) as rating_percent,ar.catid as catid,ar.sectionid as sectionid
			FROM #__content_rating AS a,#__content as ar
			WHERE ar.id=a.content_id and ar.state=1 '.$where.
			' ORDER BY '.($order_by?'hits DESC,rating_percent DESC':'rating_percent DESC,hits DESC').' LIMIT 0,'.$count;
		} else if ($source_data == 1) {
			$query = 'SELECT a.content_id as id,a.rating_count as hits,a.rating_sum as summ,ROUND((a.rating_sum/a.rating_count),2) as rating_percent,ar.catid as catid,ar.sectionid as sectionid
			FROM #__content_extravote AS a,#__content as ar
			WHERE ar.id=a.content_id and ar.state=1 AND a.extra_id = 0 '.$where.
			' ORDER BY '.($order_by?'hits DESC,rating_percent DESC':'rating_percent DESC,hits DESC').' LIMIT 0,'.$count;
		} else {
			$query = 'select id,sum(hits) as hits,sum(summ) as summ,ROUND((sum(summ)/sum(hits)),2) as rating_percent,catid,sectionid from
			(SELECT a.content_id as id,a.rating_count as hits,a.rating_sum as summ,ar.catid as catid,ar.sectionid as sectionid
			FROM #__content_rating AS a,#__content as ar
			WHERE ar.id=a.content_id and ar.state=1 '.$where.'
			union
			(SELECT a.content_id as id,a.rating_count as hits,a.rating_sum as summ,ar.catid as catid,ar.sectionid as sectionid
			FROM #__content_extravote AS a,#__content as ar
			WHERE ar.id=a.content_id and ar.state=1 AND a.extra_id = 0 '.$where.')) as table1
			GROUP BY ID, CATID, SECTIONID
			ORDER BY '.($order_by?'hits DESC,rating_percent DESC':'rating_percent DESC,hits DESC').' LIMIT 0,'.$count;
		}
		$db->setQuery($query);
		$rows = $db->loadObjectList();

		$i = 0;
		$lists = array();
		foreach ( $rows as $row )
		{
			$q3 = 'SELECT b.id,b.title,b.alias'.(modTopExtravoteHelper::ext_isJoomla('1.6', '>=')?' as title_alias':',b.title_alias').',b.catid,b.sectionid, '.
			' CASE WHEN CHAR_LENGTH(b.alias) THEN CONCAT_WS(":", b.id, b.alias) ELSE b.id END as slug ,'.
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE b.catid END as catslug '.
			'FROM `#__content` as b '.
			' LEFT JOIN #__categories AS cc ON cc.id = b.catid '.
			(modTopExtravoteHelper::ext_isJoomla('1.6', '>=')?'':' LEFT JOIN #__sections AS s ON s.id = b.sectionid ').
			'WHERE (b.id='.$row->id.') '.
			'AND (b.catid='.$row->catid.') '.
			(modTopExtravoteHelper::ext_isJoomla('1.6', '>=')?'':'AND (b.sectionid='.$row->sectionid.') ');
			//echo $q3;
			$db->setQuery($q3);
			$db->query();
			$act = $db->loadObjectList();
			if ($act) {
				$artslug = $act[0]->slug;
				$catslug = $act[0]->catslug;
				$link1 = JRoute::_(ContentHelperRoute::getArticleRoute($artslug, $catslug, $row->sectionid));
				if ($usetitlealias) {
					$lists[$i]->text = htmlspecialchars($act[0]->title_alias);
				} else {
					$lists[$i]->text = htmlspecialchars($act[0]->title);
				}
				$lists[$i]->hits = $row->hits;
				$lists[$i]->link = $link1;
				$lists[$i]->sum = $row->summ;
				$lists[$i]->id = $row->id;
				$i++;
			}
		}
		return $lists;
	}

	function ext_isJoomla($version = '', $operator = '=', $compare_minor_versions = true)
	{
		$this_version = '';
		if (!empty($GLOBALS['_VERSION']) && is_object($GLOBALS['_VERSION'])) {
			$jversion = &$GLOBALS['_VERSION'];
			$this_version = $jversion->RELEASE.'.'.$jversion->DEV_LEVEL;
		} elseif (class_exists('JVersion')) {
			$jversion = new JVersion();
			$this_version = $jversion->RELEASE.'.'.$jversion->DEV_LEVEL;
		} else {
			return false;
		}
		if (empty($version)) {
			return !empty($this_version);
		}
		$allowed_operators = array('<', 'lt', '<=', 'le', '>', 'gt', '>=', 'ge', '==', '=', 'eq', '!=', '<>', 'ne' );

		if ($compare_minor_versions) {
			$this_version = $jversion->RELEASE;
		}
		if (in_array($operator, $allowed_operators )) {
			return version_compare($this_version, $version, $operator);
		}
		return false;
	}



	function listChilds(&$db, &$id)
	{
		$i = 0;
		$list = implode(',', $id);
		$param = $list;
		do {
			$rows = modTopExtravoteHelper::getChilds($db, $param);
			$param = implode(',', $rows);
			if ($param != "") $list .= ",".$param;
		} while (count($rows) && $i++ < 10);
		return $list;
	}

	function getChilds(&$db, &$id)
	{
		$list = array();
		$query = "SELECT tbCat.id FROM #__categories AS tbCat WHERE (tbCat.parent_id IN($id) AND tbCat.published=1)";
		$db->setQuery($query);
		$db->query();
		$rows = $db->loadObjectList();
		for ($i = 0; $i < count($rows); $i++) {array_push($list, &$rows[$i]->id);}
		return $list;
	}

}
